;
;	This tests NVRAM programming in the MS-DOS environment.
;	Created	21-DEC-2000	Richard B. Johnson
;
;	Note:  There are no time-outs, this program will hang forever
;	if the chips don't work.
;
CR	EQU	0DH
LF	EQU	0AH
NVRAM_BASE	EQU	0D000H
.486
;
PSEG SEGMENT USE16 PARA PUBLIC 'Code'
	ASSUME CS:PSEG, DS:PSEG, ES:PSEG, SS:PSEG
	ORG	100H
MAIN	PROC	NEAR
	MOV	DX,OFFSET PRMT0
	MOV	AX,0900H
	INT	21H
	CALL	ERASE
	MOV	DX,OFFSET PRMT1
	MOV	AX,0900H
	INT	21H
	MOV	DX,OFFSET PRMT2
	MOV	AX,0900H
	INT	21H

	MOV	SI,OFFSET TEXT
	MOV	CX,LEN
	XOR	BX,BX			; Offset zero
	CALL	PROGRAM
	MOV	DX,OFFSET PRMT1
	MOV	AX,0900H
	INT	21H
	PUSH	DS
	MOV	AX,NVRAM_BASE
	MOV	DS,AX
	XOR	DX,DX
	MOV	AX,0900H
	INT	21h
	POP	DS
	MOV	AX,4C00H
	INT	21H
MAIN	ENDP
PRMT0	DB	'Erasing the whole bank... $'
PRMT1	DB	'done!',CR,LF,'$'
PRMT2	DB	'Programming the chip... $'


TEXT	DB	'Now is the for all good men to come to the aid '
	DB	'of the party!',CR,LF
	DB	'0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF',CR,LF
	DB	'0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF',CR,LF
	DB	'0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF',CR,LF
	DB	'0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF',CR,LF
	DB	'0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF',CR,LF
	DB	'0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF',CR,LF
	DB	'0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF',CR,LF
	DB	'0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF',CR,LF
	DB	'0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF',CR,LF
	DB	'The quick brown fox jumps over the lazy dog''s back!',CR,LF
	DB	'The quick brown fox jumps over the lazy dog''s back!',CR,LF
	DB	'The quick brown fox jumps over the lazy dog''s back!',CR,LF
	DB	'The quick brown fox jumps over the lazy dog''s back!',CR,LF
	DB	'The quick brown fox jumps over the lazy dog''s back!',CR,LF
	DB	'The quick brown fox jumps over the lazy dog''s back!',CR,LF
	DB	'The quick brown fox jumps over the lazy dog''s back!',CR,LF
	DB	'The quick brown fox jumps over the lazy dog''s back!',CR,LF
	DB	'The quick brown fox jumps over the lazy dog''s back!',CR,LF
	DB	'$'
	DB	(8192 - ($ - TEXT)) DUP(0)
LEN	EQU	($ - TEXT)
;
;	This erases the whole bank.
;
ERASE	PROC	NEAR
	PUSH	DS
	PUSH	ES
	MOV	AX,NVRAM_BASE
	MOV	DS,AX
	MOV	ES,AX
	MOV	DWORD PTR DS:[0AAAH SHL 2],0AAAAAAAAH
	MOV	DWORD PTR DS:[0555H SHL 2],055555555H
	MOV	DWORD PTR DS:[0AAAH SHL 2],080808080H
	MOV	DWORD PTR DS:[0AAAH SHL 2],0AAAAAAAAH
	MOV	DWORD PTR DS:[0555H SHL 2],055555555H
	MOV	DWORD PTR DS:[0AAAH SHL 2],010101010H

EAGAIN:	MOV	CX,2000H			; 32K sectors
	XOR	DI,DI
	MOV	EAX,0FFFFFFFFH
	CLD
	REPZ	SCASD				; See if erased
	JNZ	EAGAIN				; Do it again
EOKAY:	POP	ES
	POP	DS
	RET
ERASE	ENDP
;
;	Upon entry, DS:SI contains the address of a buffer,
;	CX contains the byte length, and BX = the offset into the device.
;
PROGRAM	PROC	NEAR
	ADD	CX,3			; We program DWORDS only
	SHR	CX,2			; Number of DWORDS
CONT:	LODSD				; Get DWORD to program
;
	PUSH	DS
	MOV	DX,NVRAM_BASE
	MOV	DS,DX			; DS points to NVRAM
	MOV	DWORD PTR DS:[0AAAH SHL 2],0AAAAAAAAH
	MOV	DWORD PTR DS:[0555H SHL 2],055555555H
	MOV	DWORD PTR DS:[0AAAH SHL 2],0A0A0A0A0H
	MOV	DWORD PTR DS:[BX],EAX	; Program data
;
TAKE:	CMP	DWORD PTR DS:[BX],EAX	; See if it went
	JNZ	TAKE			; It didn't go
TOOK:	LEA	BX,[BX+4]		; Ready next
	POP	DS
;
	LOOP	CONT			; Do all DWORDS
	RET
PROGRAM	ENDP

PSEG ENDS
	END MAIN
