;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	File SC520.INC	Created 4-DEC-2000	Richard B. Johnson
;	This was broken away from SC520.ASM on this date to make things
;	a bit easier to manipulate.
;
;	Various constants and macros are included within this file.
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
RAM_SIZE	EQU	INSTALLED_MEM	; 64 or 128 megabytes
FAR_JMP		EQU	0EAH		; FAR jump opcode
REVID		EQU	0000H
CPUCTL		EQU	0002H
DRCCTL		EQU	0010H
DRCTMCTL	EQU	0012H
DRCCFG		EQU	0014H
DRCBENDADR	EQU	0018H
ECCCTL		EQU	0020H
ECCSTA		EQU	0021H
ECCCKBPOS	EQU	0022H
ECCCKTEST	EQU	0023H
ECCSBADD	EQU	0024H
ECCMBADD	EQU	0028H
DBCTL		EQU	0040H
BOOTCSCTL	EQU	0050H
BOOTCS1CTL	EQU	0054H
ROMCS1CTL	EQU	0054H
BOOTCS2CTL	EQU	0056H
ROMCS2CTL	EQU	0056H
HBCTL		EQU	0060H
HBTGITRQCTL	EQU	0062H
HBTGITRQSTA	EQU	0064H
HBTMSTRQCTL	EQU	0066H
HBTMSTRQSTA	EQU	0068H
MSTINTADD	EQU	006CH
SYSARBCTL	EQU	0070H
PCIARBSTA	EQU	0071H
SYSARBMEMB	EQU	0072H
ARBPRICTL	EQU	0074H
ADDDECTL	EQU	0080H
WPVSTA		EQU	0082H
PAR0		EQU	0088H
PAR1		EQU	008CH
PAR2		EQU	0090H
PAR3		EQU	0094H
PAR4		EQU	0098H
PAR5		EQU	009CH
PAR6		EQU	00A0H
PAR7		EQU	00A4H
PAR8		EQU	00A8H
PAR9		EQU	00ACH
PAR10		EQU	00B0H
PAR11		EQU	00B4H
PAR12		EQU	00B8H
PAR13		EQU	00BCH
PAR14		EQU	00C0H
PAR15		EQU	00C4H
GPECHO		EQU	0C00H
GPCSDW		EQU	0C01H
GPCSQUAL	EQU	0C02H
GPCSRT		EQU	0C08H
GPCSPW		EQU	0C09H
GPCSOFF		EQU	0C0AH
GPRDW		EQU	0C0BH
GPRDOFF		EQU	0C0CH
GPWRW		EQU	0C0DH
GPWROFF		EQU	0C0EH
GPALEW		EQU	0C0FH
GPALEOFF	EQU	0C10H
PIOPFS15_0	EQU	0C20H
PIOPFS31_16	EQU	0C22H
CSPFS		EQU	0C24H
CLKSEL		EQU	0C26H
DSCTL		EQU	0C28H
PIODIR15_0	EQU	0C2AH
PIODIR31_0	EQU	0C2CH
PIODATA15_0	EQU	0C30H
PIODATA31_16	EQU	0C32H
PIOSET15_0	EQU	0C34H
PIOSET31_16	EQU	0C36H
PIOCLR15_0	EQU	0C38H
PIOCLR31_16	EQU	0C3AH
SWTMRCFG	EQU	0C64H
GPTMRSTA	EQU	0C70H
GPTMR0CTL	EQU	0C72H
GPTMR0CNT	EQU	0C74H
GPTMR0MAXCMPA	EQU	0C76H
GPTMR0MAXCMPB	EQU	0C78H
GPTMR1CTL	EQU	0C7AH
GPTMR1CNT	EQU	0C7CH
GPTMR1MAXCMPA	EQU	0C7EH
GPTMR1MAXCMPB	EQU	0C80H
GPTMR2CTL	EQU	0C82H
GPTMR2CNT	EQU	0C84H
GPTMR2MAXCMPA	EQU	0C8EH
WDTMRCTL	EQU	0CB0H
WDTMRCNTL	EQU	0CB2H
WDTMRCNTH	EQU	0CB4H
UART1CTL	EQU	0CC0H
UART1STA	EQU	0CC1H
UART1FCRSHAD	EQU	0CC2H
UART2CTL	EQU	0CC4H
UART2STA	EQU	0CC5H
UART2FCRSHAD	EQU	0CC6H
SSICTL		EQU	0CD0H
SSIXMIT		EQU	0CD1H
SSICMD		EQU	0CD2H
SSISTA		EQU	0CD3H
SSIRCV		EQU	0CD4H
PICICR		EQU	0D00H
MPICMODE	EQU	0D02H
SL1PICMODE	EQU	0D03H
SL2PICMODE	EQU	0D04H
SWINT16_1	EQU	0D08H
SWINT22_17	EQU	0D0AH
INTPINPOL	EQU	0D10H
PCIHOSTMAP	EQU	0D14H
ECCMAP		EQU	0D18H
GPTMR0MAP	EQU	0D1AH
GPTMR1MAP	EQU	0D1BH
GPTMR2MAP	EQU	0D1CH
PIT0MAP		EQU	0D20H
PIT1MAP		EQU	0D21H
PIT2MAP		EQU	0D22H
UART1MAP	EQU	0D28H
UART2MAP	EQU	0D29H
PCIINTAMAP	EQU	0D30H
PCIINTBMAP	EQU	0D31H
PCIINTCMAP	EQU	0D32H
PCIINTDMAP	EQU	0D33H
DMABCINTMAP	EQU	0D40H
SASIMAP		EQU	0D41H
WDTMAP		EQU	0D42H
RTCMAP		EQU	0D43H
WPVMAP		EQU	0D44H
ICEMAP		EQU	0D45H
FERRMAP		EQU	0D64H
GP0IMAP		EQU	0D50H
GP1IMAP		EQU	0D51H
GP2IMAP		EQU	0D52H
GP3IMAP		EQU	0D53H
GP4IMAP		EQU	0D54H
GP5IMAP		EQU	0D55H
GP6IMAP		EQU	0D56H
GP7IMAP		EQU	0D57H
GP8IMAP		EQU	0D58H
GP9IMAP		EQU	0D59H
GP10IMAP	EQU	0D5AH
SYSINFO		EQU	0D70H
RESCFG		EQU	0D72H
RESSTA		EQU	0D74H
GPDMACTL	EQU	0D80H
GPDMAMMIO	EQU	0D81H
GPDMAEXTCHMAPA	EQU	0D82H
GPDMAEXTCHMAPB	EQU	0D84H
GPDMAEXTPG0	EQU	0D86H
GPDMAEXTPG1	EQU	0D87H
GPDMAEXTPG2	EQU	0D88H
GPDMAEXTPG3	EQU	0D89H
GPDMAEXTPG5	EQU	0D8AH
GPDMAEXTPG6	EQU	0D8BH
GPDMAEXTPG7	EQU	0D8CH
GPDMAEXTTC3	EQU	0D90H
GPDMAEXTTC5	EQU	0D91H
GPDMAEXTTC6	EQU	0D92H
GPDMAEXTTC7	EQU	0D93H
GPDMABCCTL	EQU	0D98H
GPDMABCSTA	EQU	0D99H
GPDMAABSINTENB	EQU	0D9AH
GPDMABCVAL	EQU	0D9BH
GPDMANXTADDL3	EQU	0DA0H
GPDMANXTADDH3	EQU	0DA2H
GPDMANXTADDL5	EQU	0DA4H
GPDMANXTADDH5	EQU	0DA6H
GPDMANXTADDL6	EQU	0DA8H
GPDMANXTADDH6	EQU	0DAAH
GPDMANXTADDL7	EQU	0DACH
GPDMANXTADDH7	EQU	0DAEH
GPDMANXTTCL3	EQU	0DB0H
GPDMANXTTCH3	EQU	0DB2H
GPDMANXTTCL5	EQU	0DB4H
GPDMANXTTCH5	EQU	0DB6H
GPDMANXTTCL6	EQU	0DB8H
GPDMANXTTCH6	EQU	0DBAH
GPDMANXTTCL7	EQU	0DBCH
GPDMANXTTCH7	EQU	0DBEH
PCICFGADR	EQU	0CF8H
PCICFGDATA	EQU	0CFCH
MCR_SEG		EQU	0E000H			; MCR Segment
CBAR		EQU	0FFFCH
ROM_SEG		EQU	0F000H			; BIOS ROM here
SCR_SEG		EQU	0C000H			; Possible screen BIOS
CPY_SEG		EQU	01000H			; Work space
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	The PCI interrupts have been chosen as IRQ9 thru IRQ12.
;	From Page 12-18 of the Register Set Manual, we see that
;	the following applies:
;
PCI_IRQ9	EQU	00000100B		; Mapping to IRQ9
PCI_IRQ10	EQU	00000101B		; Mapping to IRQ10
PCI_IRQ11	EQU	00000110B		; Mapping to IRQ11
PCI_IRQ12	EQU	00000111B		; Mapping to IRQ12
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	The PARS are hard to read and manipulate. Therefore we define
;	some MACROS. This means that once we figure them out, they
;	will all be correct.
;
PAR_TARG_DISAB	EQU	0 SHL 29
PAR_TARG_GPIO	EQU	1 SHL 29
PAR_TARG_GPMEM	EQU	2 SHL 29
PAR_TARG_PCIMEM	EQU	3 SHL 29
PAR_TARG_BOOTCS	EQU	4 SHL 29
PAR_TARG_ROMCS1	EQU	5 SHL 29
PAR_TARG_ROMCS2	EQU	6 SHL 29
PAR_TARG_SDRAM	EQU	7 SHL 29
;
PAR_ATTR_GPCS0	EQU	0 SHL 26
PAR_ATTR_GPCS1	EQU	1 SHL 26
PAR_ATTR_GPCS2	EQU	2 SHL 26
PAR_ATTR_GPCS3	EQU	3 SHL 26
PAR_ATTR_GPCS4	EQU	4 SHL 26
PAR_ATTR_GPCS5	EQU	5 SHL 26
PAR_ATTR_GPCS6	EQU	6 SHL 26
PAR_ATTR_GPCS7	EQU	7 SHL 26
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	The following attributes are for SDRAM or ROM.
;
PAR_ATTR_WPROT	EQU	1 SHL 26
PAR_ATTR_DCACHE	EQU	2 SHL 26
PAR_ATTR_NEXEC	EQU	4 SHL 26
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	The following defines the page sizes.
;
PAR_PAGE_4KB	EQU	0 SHL 25
PAR_PAGE_64KB	EQU	1 SHL 25
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	This defines a memory region for the GP bus and puts the
;	value into the PAR register.
;
MEM_REGION_PAR MACRO ADDR, LEN, PAR
	N = (ADDR AND 3FFFH)
	N = N OR (((LEN - 1) AND 7FFH) SHL 14)
	N = N OR PAR_ATTR_DCACHE
	N = N OR PAR_TARG_GPMEM
	N = N OR PAR_PAGE_64KB
	MOV	DWORD PTR DS:[PAR],N
ENDM
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;	This defines a memory region using chip-select 2 and puts
;	the value into a PAR register
;
MEM_REGION_CS3 MACRO ADDR, LEN, PAR
	N = (ADDR AND 3FFFH)
	N = N OR (((LEN -1) AND 7FFH) SHL 14)
	N = N OR PAR_ATTR_GPCS3
	N = N OR PAR_TARG_GPMEM
	N = N OR PAR_PAGE_64KB
	MOV	DWORD PTR DS:[PAR],N
ENDM
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	This defines a memory region for the PCI bus and puts the
;	value into the PAR register.
;
PCI_REGION_PAR MACRO ADDR, LEN, PAR
	N = (ADDR AND 3FFFH)
	N = N OR (((LEN - 1) AND 7FFH) SHL 14)
	N = N OR PAR_ATTR_DCACHE
	N = N OR PAR_TARG_PCIMEM
	N = N OR PAR_PAGE_64KB
	MOV	DWORD PTR DS:[PAR],N
ENDM
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	This write-protects a memory region.
;
MEM_WPROT_PAR MACRO ADDR, LEN, PAR
	N = (ADDR AND 3FFFH)
	N = N OR (((LEN -1) AND 7FFH) SHL 14)
	N = N OR PAR_TARG_SDRAM
	N = N OR PAR_PAGE_64KB
	N = N OR PAR_ATTR_WPROT
	MOV	DWORD PTR DS:[PAR],N
ENDM
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	This defines the I/O region for the GP bus and puts the value
;	into the PAR register.
;
IO_REGION_PAR MACRO STRT, PEND, PAR
	N = (STRT AND 0FFFFH)
        N = N OR (((PEND - STRT) AND 1FFH) SHL 16)
        N = N OR PAR_TARG_GPIO
	MOV	DWORD PTR DS:[PAR],N
ENDM
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	This enables the BOOT ROM so that its top 64k exists at
;	F000:0000H as required by the PC/AT specs.
;
BOOT_PROM_PAR MACRO BASE, PAR
	N = PAR_TARG_BOOTCS			; Target BOOT ROM
        N = N OR PAR_ATTR_WPROT			; Write protect
	N = N OR PAR_PAGE_4KB			; 4 kilobyte pages
        N = N OR (((0FFFFFH-BASE)/1000H) SHL 18); Size of address space
	N = N OR ((BASE SHR 12) AND 1FFFH)	; Base address
	MOV	DWORD PTR DS:[PAR],N		; Program the PAR
ENDM
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	This puts the BOOT ROM BIOS chip at an absolute address.
;
BOOT_ROM_SETUP MACRO ADDR, LEN, PAR
	MOV WORD PTR DS:[BOOTCSCTL],0001100000000011B
;	                               | ||||| ||  |____ First delay
;	                               | ||||| ||_______ Reserved
;	                               | ||||| |________ Sub delay
;	                               | |||||__________ Reserved
;	                               | ||_____________ Page/nopage 1:0
;	                               | |______________ Width 8/16/32 0/1/2
;	                               |________________ SDRAM/GPB 1:0
;
	N = PAR_TARG_BOOTCS			; Target BOOT ROM
	N = N OR PAR_ATTR_DCACHE		; Disable caching
	N = N OR (ADDR AND 1FFFH)		; Base address
	N = N OR (((LEN -1) AND 7FFH) SHL 14)	; Length in pages
	N = N OR PAR_PAGE_64KB			; 64 Kilobyte pages
	MOV	DWORD PTR DS:[PAR],N		; Program the PAR
ENDM
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	This enables the first 64k of NVRAM. It's bottom must
;	exist at D000:0000 in SDRAM memory address space.
;
NVRAM_DEV_PAR MACRO ADDR, LEN, PAR
	MOV WORD PTR DS:[ROMCS1CTL],0001110000000111B
;	                               | ||||| ||  |____ First delay
;	                               | ||||| ||_______ Reserved
;	                               | ||||| |________ Sub delay
;	                               | |||||__________ Reserved
;	                               | ||_____________ Page/nopage 1:0
;	                               | |______________ Width 8/16/32 0/1/2
;	                               |________________ SDRAM/GPB 1:0
;
	N = (ADDR AND 7FFH)			; Base address
	N = N OR (((LEN - 1) AND 7FFH) SHL 14)	; Length in 64k blocks
	N = N OR PAR_ATTR_DCACHE		; Do not cache
	N = N OR PAR_TARG_ROMCS1		; Set first NVRAM device
	N = N OR PAR_PAGE_64KB			; 64k pages
	MOV	DWORD PTR DS:[PAR],N		; Set address register
ENDM
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	This just clears a PAR region in a consistent manner.
;
CLEAR_REGION_PAR MACRO PAR
	MOV	DWORD PTR DS:[PAR],00000000H
ENDM
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	This copies the contents of RAM from one non-overlapping
;	64k segment to another. Most all registers are destroyed.
;
COPY64K	MACRO FROM, TO
	XOR	SI,SI			; Get a zero
	MOV	DI,SI			; DI=SI=0
	MOV	AX,FROM			; Source segment
	MOV	DS,AX			; DS:SI = source
	MOV	AX,TO			; Destination segmentg
	MOV	ES,AX			; ES:SI = destination
	MOV	CX,8000H		; 64k in words
	REP	MOVSW			; Copy the data
ENDM
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
;	This clears a 64k segment of RAM. Registers are destroyed.
;
CLEAR64K MACRO WHERE
	XOR	DI,DI			; Offset zero
	MOV	AX,WHERE		; Segment to clear
	MOV	ES,AX			; ES:DI = destination
	XOR	AX,AX			; Zero
	MOV	CX,8000H		; 64k in words
	REP	STOSW			; Clear
ENDM
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;-=-=-=-=-=-=-=-=-=-=-=-=-=-= END of SC520.INC -=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
